﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.Pex.Framework;
using Microsoft.Pex.Framework.Instrumentation;

[assembly: PexAssemblyUnderTest("RedBlackTree.RedBlackTree")]

namespace TestProjectPlanterPex
{
    [PexClass((typeof(RedBlackTree.RedBlackTree)))]//on se concentre sur la couverture des branches de la classe RedBlackTree

    public partial class UnitTestRedBlackTree
    {

        [PexMethod]
        public void testRedBlackTree1(RedBlackTree.RedBlackTree r, RedBlackTree.Entry p)
        {
            if (r != null)
            {
                r.rotateLeft(p);
            }
        }


        [PexMethod(MaxRunsWithoutNewTests = 1000000, Timeout = 1000000000, MaxRuns = 10000, MaxConstraintSolverTime = 2)]
        public void testRedBlackTree2(RedBlackTree.RedBlackTree r, RedBlackTree.Entry p)
        {
            if (r != null)
            {
                r.fixAfterInsertion(p);
            }
        }

        //Remark : the bounds have been increased step by step without improving coverage
        [PexMethod(MaxRunsWithoutNewTests = 1600, MaxBranches = 3200, Timeout = 3600, MaxRuns = 2000)]
        public void testRedBlackTree3(RedBlackTree.RedBlackTree r, RedBlackTree.Entry p)
        {
            if (r != null)
            {
                r.fixAfterDeletion(p);

            }
        }


        [PexMethod(MaxConditions = 1000000000, MaxBranches = 1000000000, Timeout = 3600, MaxExecutionTreeNodes = 1000000000)]
        public void testRedBlackTree4(RedBlackTree.RedBlackTree r, RedBlackTree.Entry p)
        {
            if (r != null)
            {
                r.deleteEntry(p);
            }
        }

    }
}